/*
 *  linux/arch/arm/mach-mb86hxx/gpio.c
 *
 * Copyright (C) 2010 FUJITSU MICROELECTRONICS LIMITED
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <linux/io.h>
#include <mach/hardware.h>
#include <mach/gpio.h>

int mb86h6X_gpio_config_out(int gpio, int function)
{
	void __iomem *reg;

	reg = (void *)(MB86HXX_GPIO_VA_BASE + GPIO_CONFIG_DATAOUT + gpio*4);
	__raw_writel(function, reg);
	return 0;
}

int mb86h6X_gpio_config_in(int gpio, int function)
{
	void __iomem *reg;

	reg = (void *)(MB86HXX_GPIO_VA_BASE + GPIO_CONFIG_DATAIN + function*4);
	__raw_writel(gpio + 2, reg);
	return 0;
}
