/*
 * linux/arch/arm/mach-mb86hxx/include/mach/gpio.h
 *
 * Copyright (C) 2010 FUJITSU MICROELECTRONICS LIMITED
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef __ASM_ARCH_MACH_GPIO_H
#define __ASM_ARCH_MACH_GPIO_H

/* Offset of Registers */
#define GPIO_CONFIG_DATAOUT 0x0
#define GPIO_CONFIG_DATAIN  0x200
#define GPIO_IRQ_CONFIG     0x4c0
#define GPIO_CONFIG	    0x4c4
#define GPIO_PWM_SETTING    0x4ec
#define GPIO_IRQ_STATUS     0x400
#define GPIO_INPUT_31	    0x404
#define GPIO_INPUT_63	    0x408
#define GPIO_INPUT_95	    0x40c

/* Function to be assigned */
	/* OUTPUT */
#define GPIO_FUNCTION_UART0_TXDATA 23
#define GPIO_FUNCTION_UART1_TXDATA 44

	/* INPUT */
#define GPIO_FUNCTION_UART0_RXDATA 21
#define GPIO_FUNCTION_UART1_RXDATA 64

extern int mb86h6X_gpio_config_out(int, int);
extern int mb86h6X_gpio_config_in(int, int);

#endif				/* __ASM_ARCH_MACH_GPIO_H */
